/*
	PoCgCRC32vZ[`
*/
module crc32_sync8(I_RESET,I_CLK,I_FEED,I_CRC32,I_SIN8,I_LOAD,I_START,O_CRC32,O_READY);

// ̓|[g
input	I_RESET;
input	I_CLK;
input	[31:0]  I_FEED;
input	[31:0]  I_CRC32;
input	[7:0]	I_SIN8;
input	I_START;
input	I_LOAD;
// o̓|[g
output  [31:0] O_CRC32;
output  O_READY;

// Lfq(RTLLq'R'j
reg	[2:0]	bit_counter;
reg	[7:0]	reg_shift_data;
reg	[31:0] reg_crc32;
reg	reg_busy;

wire [31:0] crc32_out;

// ʃW[Ƃ̐ڑ
crc32_async crc32_async(
	.I_FEED(I_FEED),
	.I_CRC32(reg_crc32),
	.I_DATA(reg_shift_data[7]),
	.O_CRC32(crc32_out)
);

// Xe[g}V
always @(posedge I_CLK)
begin
	// X^[g
	if(I_RESET) begin						// ZbgTCN
		bit_counter    <= 3'h0;
		reg_shift_data <= 8'h00;
		reg_crc32      <= 32'hffffffff;
		reg_busy       <= 1'b0;
	end else begin						// ZbgȊÕTCN
		if(reg_busy==1'b0) begin		// ҋ@
			if(I_START) begin							// STARTMtH
				reg_busy       <= 1'b1;
				bit_counter    <= 3'h0;
				reg_shift_data <= I_SIN8;
			end
			if(I_LOAD) begin							// [htH
				reg_crc32 <= I_CRC32;
			end
		end else begin							// 쒆
			// crc32XV
			reg_crc32 <= crc32_out;
			// f[^̍Vtg
			reg_shift_data <= {reg_shift_data[6:0],1'b0};
			// rbg̃JEgAbv
			bit_counter <= bit_counter + 1;
			if(bit_counter==3'h7)			// WځH
			begin
				reg_busy  <= 1'b0; // I
			end
		end
	end
end

// o͐M
assign O_CRC32 = reg_crc32;
assign O_READY = (reg_busy==1'b0);

endmodule
