/////////////////////////////////////////////////////////////////////////////
// crc32vZf@eXgx` Type 2
//
// testdata.bint@CǂݍŁAcrc32lvZȂ\܂B
//
/////////////////////////////////////////////////////////////////////////////

//`timescale 1ps/1ps
`timescale 10us/10us

// ̑I
`define POLYNOMIAL_CRC32_IEEE802_3  32'h04C11DB7
`define POLYNOMIAL_CRC16_CCITT      32'h10210000

`define TEST_FILEPATH "c:/rand10mb.bin"

// V~[VoCg
// `define SIMURATE_BYTES (10*1024*1024)
//`define SIMURATE_BYTES (1024)
`define SIMURATE_BYTES (100*1024)

module sim_crc32s_file;

/////////////////////////////////////////////////////////////////////////////
// ^[QbgW[̐ڑ
/////////////////////////////////////////////////////////////////////////////

reg	[7:0] I_DATA;
reg	RESET;
reg	LOAD;
reg	START;
reg	CLOCK;
reg	[31:0]  I_CRC32;
reg	[31:0]  I_POLYNOMIAL;

wire READY;
wire    [31:0]  O_CRC32;

crc32_sync8 crc32_sync8(
	.I_RESET(RESET),
	.I_CLK(CLOCK),
	.I_FEED(I_POLYNOMIAL),
	.I_CRC32(I_CRC32),
	.I_SIN8(I_DATA),
	.I_LOAD(LOAD),
	.I_START(START),
	.O_CRC32(O_CRC32),
	.O_READY(READY)
);

/////////////////////////////////////////////////////////////////////////////
// NbNpX̋
// NbN2TCN x 10us = 20us = 50MHzł邪A
// PwZGbWNbNHł́ANbNTCNԂƂȂ̂
// _xV~[Ṽxł͎Ԃ͈ӖȂ
/////////////////////////////////////////////////////////////////////////////
always
begin
	#1 CLOCK = ~CLOCK;
end

/////////////////////////////////////////////////////////////////////////////
// PoCgCRC32vZV~[V
/////////////////////////////////////////////////////////////////////////////
task crc32_byte_out;
input [7:0] byte_data;
begin
	I_DATA = byte_data;

	START  = 1'b1;		// X^[g
	#2;
	START  = 1'b0; // 󂯕t猳ɖ߂
	// vZI܂ł܂iWNbNj
	while(READY!=1'b1)
	begin
		#2;
	end
end
endtask

/////////////////////////////////////////////////////////////////////////////
// PoCgt@C
/////////////////////////////////////////////////////////////////////////////
task file_getc;
input integer fn;
output [7:0] data;
output integer eof;

integer getc_data;
begin
  getc_data = $fgetc(fn);
	data = getc_data[7:0];
	eof  = (getc_data==32'hffffffff) ? 1 : 0;
end
endtask

/////////////////////////////////////////////////////////////////////////////
// t@CCRCvZ
/////////////////////////////////////////////////////////////////////////////
task crc_file_calc;
input integer fn;
input integer bit_size;
input [31:0] crc_initial;
input [31:0] crc_polunomial;
output [31:0] crc;

integer num_calc;
integer eof_flag;
reg [7:0] crc_din;
begin
	// Əlݒ
  I_POLYNOMIAL  = crc_polunomial;
  I_CRC32       = crc_initial;
	crc = crc_initial;
	// ^[QbgHɃ[h
	LOAD  = 1'b1;
	#2
	LOAD  = 1'b0;

	eof_flag=0;
	for(num_calc=0;(num_calc<`SIMURATE_BYTES);num_calc= num_calc+1)
	begin
		// t@CPoCg[h
		file_getc(infile,crc_din,eof_flag);
		// PoCgCRCvZ
   	crc32_byte_out(crc_din);
//   $display("byte %X,CRC32=%X",crc_din,O_CRC32>>(32-bit_size) );
	end
	crc = O_CRC32;
  $display("Finish CRC calcrate");
end
endtask

/////////////////////////////////////////////////////////////////////////////
// V~[V
/////////////////////////////////////////////////////////////////////////////
integer infile;
reg [31:0] crc32;
reg [31:0] crc16;
integer result;

initial begin

	// 
	RESET = 1'b1;
	LOAD  = 1'b0;
	START = 1'b0;
	CLOCK = 1'b0;

	// NbN
	if(CLOCK) #1;

	// CRCjbg̃Zbg҂
	#2
	#2
	// Zbg
	RESET = 1'b0;
	#2

	// t@CCRC32vZ
  infile = $fopen(`TEST_FILEPATH, "rb");
	if(infile==0)
	begin
    $display("Can't open in file\n");
		$finish;
	end
	crc_file_calc(infile,32,32'hffffffff,`POLYNOMIAL_CRC32_IEEE802_3,crc32);
  $fclose(infile);

	// t@CCRC16vZ
  infile = $fopen(`TEST_FILEPATH, "rb");
	if(infile==0)
	begin
    $display("Can't open in file\n");
		$finish;
	end
	crc_file_calc(infile,32,32'hffff0000,`POLYNOMIAL_CRC16_CCITT,crc16);
  $fclose(infile);

	$display("CRC32 = %X",crc32);
	$display("CRC16 = %X",crc16[31:16]);

  $finish;
end

endmodule

